#include <bindings.dsl.h>

-- | <http://gts.sourceforge.net/reference/gts-bounding-boxes-trees.html>

module Bindings.Gts.GeometricalDataStructures.BoundingBoxesTrees where
import Bindings.GLib
import Bindings.Gts.Types
#strict_import

#cinline GTS_BBOX_CLASS , Ptr a -> Ptr <GtsBBoxClass>
#cinline GTS_BBOX , Ptr a -> Ptr <GtsBBox>
#cinline GTS_IS_BBOX , Ptr a -> Ptr <gboolean> 

#ccall gts_bbox_class , IO (Ptr <GtsBBoxClass>) 
#ccall gts_bbox_new , Ptr <GtsBBoxClass> -> <gpointer> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> IO (Ptr <GtsBBox>) 
#ccall gts_bbox_set , Ptr <GtsBBox> -> <gpointer> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> IO ()
#ccall gts_bbox_segment , Ptr <GtsBBoxClass> -> Ptr <GtsSegment> -> IO (Ptr <GtsBBox>) 
#ccall gts_bbox_triangle , Ptr <GtsBBoxClass> -> Ptr <GtsTriangle> -> IO (Ptr <GtsBBox>) 
#ccall gts_bbox_surface , Ptr <GtsBBoxClass> -> Ptr <GtsSurface> -> IO (Ptr <GtsBBox>) 
#ccall gts_bbox_points , Ptr <GtsBBoxClass> -> Ptr <GSList> -> IO (Ptr <GtsBBox>) 
#ccall gts_bbox_bboxes , Ptr <GtsBBoxClass> -> Ptr <GSList> -> IO (Ptr <GtsBBox>) 
#ccall gts_bbox_draw , Ptr <GtsBBox> -> Ptr CFile -> IO ()

#cinline gts_bbox_point_is_inside , Ptr <GtsBBox> -> Ptr <GtsPoint> -> IO <gboolean>

#ccall gts_bboxes_are_overlapping , Ptr <GtsBBox> -> Ptr <GtsBBox> -> IO <gboolean>
#ccall gts_bbox_diagonal2 , Ptr <GtsBBox> -> IO <gdouble>
#ccall gts_bbox_point_distance2 , Ptr <GtsBBox> -> Ptr <GtsPoint> -> Ptr <gdouble> -> Ptr <gdouble> -> IO ()
#ccall gts_bbox_is_stabbed , Ptr <GtsBBox> -> Ptr <GtsPoint> -> IO <gboolean>
#ccall gts_bbox_overlaps_triangle , Ptr <GtsBBox> -> Ptr <GtsTriangle> -> IO <gboolean>

#ccall gts_bb_tree_new , Ptr <GSList> -> IO (Ptr <GNode>) 
#ccall gts_bb_tree_surface , Ptr <GtsSurface> -> IO (Ptr <GNode>) 
#ccall gts_bb_tree_overlap , Ptr <GNode> -> Ptr <GtsBBox> -> IO (Ptr <GSList>) 
#ccall gts_bb_tree_is_overlapping , Ptr <GNode> -> Ptr <GtsBBox> -> IO <gboolean>
#ccall gts_bb_tree_traverse_overlapping , Ptr <GNode> -> Ptr <GNode> -> <GtsBBTreeTraverseFunc> -> <gpointer> -> IO ()
#ccall gts_bb_tree_draw , Ptr <GNode> -> <guint> -> Ptr CFile -> IO ()
#ccall gts_bb_tree_destroy , Ptr <GNode> -> <gboolean> -> IO ()

#ccall gts_bb_tree_point_distance , Ptr <GNode> -> Ptr <GtsPoint> -> <GtsBBoxDistFunc> -> Ptr (Ptr <GtsBBox>) -> IO <gdouble>
#ccall gts_bb_tree_point_closest , Ptr <GNode> -> Ptr <GtsPoint> -> <GtsBBoxClosestFunc> -> Ptr <gdouble> -> IO (Ptr <GtsPoint>) 
#ccall gts_bb_tree_segment_distance , Ptr <GNode> -> Ptr <GtsSegment> -> <GtsBBoxDistFunc> -> <gdouble> -> Ptr <GtsRange> -> IO ()
#ccall gts_bb_tree_triangle_distance , Ptr <GNode> -> Ptr <GtsTriangle> -> <GtsBBoxDistFunc> -> <gdouble> -> Ptr <GtsRange> -> IO ()
#ccall gts_bb_tree_point_closest_bboxes , Ptr <GNode> -> Ptr <GtsPoint> -> IO (Ptr <GSList>) 
#ccall gts_bb_tree_surface_boundary_distance , Ptr <GNode> -> Ptr <GtsSurface> -> <GtsBBoxDistFunc> -> <gdouble> -> Ptr <GtsRange> -> IO ()
#ccall gts_bb_tree_surface_distance , Ptr <GNode> -> Ptr <GtsSurface> -> <GtsBBoxDistFunc> -> <gdouble> -> Ptr <GtsRange> -> IO ()
#ccall gts_bb_tree_stabbed , Ptr <GNode> -> Ptr <GtsPoint> -> IO (Ptr <GSList>) 
