#include <bindings.dsl.h>
#include <gts.h>

-- | <http://gts.sourceforge.net/reference/gts-container-classes.html>

module Bindings.Gts.GeometricalObjectHierarchy.ContainerClasses where
import Bindings.GLib
import Bindings.Gts.Types
#strict_import

#cinline GTS_CONTAINER_CLASS , Ptr a -> Ptr <GtsContainerClass>
#cinline GTS_CONTAINER , Ptr a -> Ptr <GtsContainer>
#cinline GTS_IS_CONTAINER , Ptr a -> Ptr <gboolean> 

#ccall gts_container_class , IO (Ptr <GtsContainerClass>) 
#ccall gts_container_new , Ptr <GtsContainerClass> -> IO (Ptr <GtsContainer>) 
#ccall gts_container_add , Ptr <GtsContainer> -> Ptr <GtsContainee> -> IO ()
#ccall gts_container_remove , Ptr <GtsContainer> -> Ptr <GtsContainee> -> IO ()
#ccall gts_container_size , Ptr <GtsContainer> -> IO <guint>
#ccall gts_container_foreach , Ptr <GtsContainer> -> <GtsFunc> -> <gpointer> -> IO ()

#cinline GTS_HASH_CONTAINER_CLASS , Ptr a -> Ptr <GtsHashContainerClass>
#cinline GTS_HASH_CONTAINER , Ptr a -> Ptr <GtsHashContainer>
#cinline GTS_IS_HASH_CONTAINER , Ptr a -> Ptr <gboolean> 

#ccall gts_hash_container_class , IO (Ptr <GtsHashContainerClass>) 

#cinline GTS_SLIST_CONTAINER_CLASS , Ptr a -> Ptr <GtsSListContainerClass>
#cinline GTS_SLIST_CONTAINER , Ptr a -> Ptr <GtsSListContainer>
#cinline GTS_IS_SLIST_CONTAINER , Ptr a -> Ptr <gboolean> 

#ccall gts_slist_container_class , IO (Ptr <GtsSListContainerClass>) 
