#include <bindings.dsl.h>

-- | <http://gts.sourceforge.net/reference/gts-graph-class.html>

module Bindings.Gts.GraphAndOperationsOnGraphs.GraphClass where
import Bindings.GLib
import Bindings.Gts.Types
#strict_import

#cinline GTS_GNODE_CLASS , Ptr a -> Ptr <GtsGNodeClass>
#cinline GTS_GNODE , Ptr a -> Ptr <GtsGNode>
#cinline GTS_IS_GNODE , Ptr a -> Ptr <gboolean> 

#cinline GTS_GNODE_NEIGHBOR , Ptr <GtsGNode> -> Ptr <GtsGEdge> -> IO (Ptr <GtsGNode>)

#ccall gts_gnode_class , IO (Ptr <GtsGNodeClass>) 
#ccall gts_gnode_new , Ptr <GtsGNodeClass> -> IO (Ptr <GtsGNode>) 
#ccall gts_gnode_degree , Ptr <GtsGNode> -> Ptr <GtsGraph> -> IO <guint>
#ccall gts_gnode_foreach_edge , Ptr <GtsGNode> -> Ptr <GtsGraph> -> <GtsFunc> -> <gpointer> -> IO ()
#ccall gts_gnode_foreach_neighbor , Ptr <GtsGNode> -> Ptr <GtsGraph> -> <GtsFunc> -> <gpointer> -> IO ()
#ccall gts_gnode_weight , Ptr <GtsGNode> -> IO <gfloat>
#ccall gts_gnode_move_cost , Ptr <GtsGNode> -> Ptr <GtsGraph> -> Ptr <GtsGraph> -> IO <gfloat>

#cinline GTS_GEDGE_CLASS , Ptr a -> Ptr <GtsGEdgeClass>
#cinline GTS_GEDGE , Ptr a -> Ptr <GtsGEdge>
#cinline GTS_IS_GEDGE , Ptr a -> Ptr <gboolean> 

#ccall gts_gedge_class , IO (Ptr <GtsGEdgeClass>) 
#ccall gts_gedge_new , Ptr <GtsGEdgeClass> -> Ptr <GtsGNode> -> Ptr <GtsGNode> -> IO (Ptr <GtsGEdge>) 
#ccall gts_gedge_weight , Ptr <GtsGEdge> -> IO <gfloat>

#cinline gts_gedge_connects , Ptr <GtsGEdge> -> Ptr <GtsGNode> -> Ptr <GtsGNode> -> IO <gboolean>

#cinline GTS_GRAPH_CLASS , Ptr a -> Ptr <GtsGraphClass>
#cinline GTS_GRAPH , Ptr a -> Ptr <GtsGraph>
#cinline GTS_IS_GRAPH , Ptr a -> Ptr <gboolean> 

#ccall gts_graph_class , IO (Ptr <GtsGraphClass>) 
#ccall gts_graph_new , Ptr <GtsGraphClass> -> Ptr <GtsGNodeClass> -> Ptr <GtsGEdgeClass> -> IO (Ptr <GtsGraph>) 
#ccall gts_graph_read , Ptr <GtsFile> -> IO (Ptr <GtsGraph>) 
#ccall gts_graph_read_jostle , Ptr <GtsGraph> -> Ptr <GtsFile> -> IO <guint>
#ccall gts_graph_write , Ptr <GtsGraph> -> Ptr CFile -> IO ()
#ccall gts_graph_write_dot , Ptr <GtsGraph> -> Ptr CFile -> IO ()
#ccall gts_graph_print_stats , Ptr <GtsGraph> -> Ptr CFile -> IO ()
#ccall gts_graph_foreach_edge , Ptr <GtsGraph> -> <GtsFunc> -> <gpointer> -> IO ()

#ccall gts_graph_traverse_new , Ptr <GtsGraph> -> Ptr <GtsGNode> -> <GtsTraverseType> -> <gboolean> -> IO (Ptr <GtsGraphTraverse>) 
#ccall gts_graph_traverse_next , Ptr <GtsGraphTraverse> -> IO (Ptr <GtsGNode>) 
#ccall gts_graph_traverse_what_next , Ptr <GtsGraphTraverse> -> IO (Ptr <GtsGNode>) 
#ccall gts_graph_traverse_destroy , Ptr <GtsGraphTraverse> -> IO ()
#ccall gts_graph_edges_cut , Ptr <GtsGraph> -> IO <guint>
#ccall gts_graph_edges_cut_weight , Ptr <GtsGraph> -> IO <gfloat>
#ccall gts_graph_distance_sum , Ptr <GtsGraph> -> Ptr <GtsGNode> -> IO <guint>
#ccall gts_graph_farthest , Ptr <GtsGraph> -> Ptr <GSList> -> IO (Ptr <GtsGNode>) 
#ccall gts_graph_weight , Ptr <GtsGraph> -> IO <gfloat>

#cinline GTS_FNODE_CLASS , Ptr a -> Ptr <GtsFNodeClass>
#cinline GTS_FNODE , Ptr a -> Ptr <GtsFNode>
#cinline GTS_IS_FNODE , Ptr a -> Ptr <gboolean> 

#ccall gts_fnode_class , IO (Ptr <GtsFNodeClass>) 
#ccall gts_fnode_new , Ptr <GtsFNodeClass> -> Ptr <GtsFace> -> IO (Ptr <GtsFNode>) 

#ccall gts_surface_graph_new , Ptr <GtsGraphClass> -> Ptr <GtsSurface> -> IO (Ptr <GtsGraph>) 
#ccall gts_surface_graph_surface , Ptr <GtsGraph> -> Ptr <GtsSurface> -> IO (Ptr <GtsSurface>) 
#ccall gts_segments_graph_new , Ptr <GtsGraphClass> -> Ptr <GSList> -> IO (Ptr <GtsGraph>) 
